package RRD::Cache::Apache;

#
# Cache::Apache 1.3 + 2.0 cache 
# Reads url and store /server-status
#
# $Id: Apache.pm,v 1.8 2002/04/08 11:44:37 tommy Exp $
#

use strict;

use LWP::UserAgent;
use RRD::Cache;
use vars qw(@ISA);

@ISA = qw(RRD::Cache);

sub GetContent {
    my ($self) = @_;

    my $u = new LWP::UserAgent;
    my $ur = new HTTP::Request(GET=>$self->{Target});
    my $res = $u->request($ur);

    if ($res->is_success) {
  	return $res->content;
    }else{
        return undef;
    }
}

sub Load {
    my ($self) = @_;

    $self->{value} =~ m/Total Accesses: (\d+).*Total kBytes: (\d+).*CPULoad: ([\d.]+).*Uptime: (\d+).*BytesPerReq: (\d+).*Busy\w+: (\d+).*Idle\w+: (\d+)/gs;

    $self->{total_accesses} = $1;
    $self->{total_bytes}    = $2 * 1000;
    $self->{cpu_load}       = $3 * 100;
    $self->{uptime}         = $4;
    $self->{bytes_per_req}  = $5;
    $self->{busyservers}    = $6;
    $self->{idleservers}    = $7;
}

sub total_accesses {
    my ($self) = @_;
    return $self->{total_accesses};
}

sub total_bytes {
    my ($self) = @_;
    return $self->{total_bytes};
}

sub cpu_load {
    my ($self) = @_;
    return $self->{cpu_load};
}

sub bytes_per_req {
    my ($self) = @_;
    return $self->{bytes_per_req};
}

sub servers_busy {
    my ($self) = @_;
    return $self->{busyservers};
}

sub servers_idle {
    my ($self) = @_;
    return $self->{idleservers};
}

sub uptime {
    my ($self) = @_;
    return $self->{uptime};
}    

1;
