package RRD::Cache::Bind;

#
# Cache::Bind cache progam
# Reads/Write bind (named) statistics
#
# $Id: Bind.pm,v 1.5 2002/10/05 12:46:11 tommy Exp $
#

use strict;
use SNMP_util;
use RRD::Cache;
use Net::Telnet;

use vars qw(@ISA $ifDescrOid $TIMEOUT);
@ISA = qw(RRD::Cache);

$TIMEOUT = 300;

sub GetContent {
    my ($self) = @_;

    my ($port,$ip) = split("@",$self->{Target});
    my $telnet = new Net::Telnet(Host => $ip, 
    				 Port => $port, 
				 Timeout => 30,
				 Errmode => 'return' 
				);
    if ( ! $telnet ) { return undef; }

    my $val = "";
    while(! $telnet->eof ) { 
	$_ = $telnet->getline;
        $val .= $_ ? $_ : "" ; 
    }
    $telnet->close;

    return $val;
}

sub Load {
    my ($self) = @_;

    $self->{value} =~ m/(\d+)\ttime since reset.*\s(\d+)\tA queries.*\s(\d+)\tNS queries.*\s(\d+)\tPTR queries.*\s(\d+)\tMX queries/gs;
    
    $self->{uptime}    = $1;
    $self->{query_a}   = $2;
    $self->{query_ns}  = $3;
    $self->{query_ptr} = $4;
    $self->{query_mx}  = $5;
}

sub uptime {
    my ($self) = @_;
    return defined $self->{uptime} ? $self->{uptime} : 0;
}

sub query_a {
    my ($self) = @_;
    return $self->{query_a};
}

sub query_ns {
    my ($self) = @_;
    return $self->{query_ns};
}

sub query_ptr {
    my ($self) = @_;
    return $self->{query_ptr};
}

sub query_mx {
    my ($self) = @_;
    return $self->{query_mx};
}

1;
