package RRD::Cache::ProcStat;

#
# Cache::ProcStat /proc/stat cache progam
# Tested on Linux 2.4.20+, doesn't work in 2.5+
# See README.Modules on installing procstat.sh binary from inetd
# Has multiple modules; lindiskio lindiskblk linofiles linsockets
#
# $Id: ProcStat.pm,v 1.2 2003/06/21 17:21:09 tommy Exp $
#

use strict;
use SNMP_util;
use RRD::Cache;
use Net::Telnet;

use vars qw(@ISA $ifDescrOid $TIMEOUT);
@ISA = qw(RRD::Cache);

$TIMEOUT = 300;

sub GetContent {
    my ($self) = @_;

    my ($port,$ip) = split("@",$self->{Target});
    my $telnet = new Net::Telnet(Host => $ip, 
    				 Port => $port, 
				 Timeout => 30,
				 Errmode => 'return' 
				);
    if ( ! $telnet ) { return undef; }

    my $val = "";
    while(! $telnet->eof ) { 
	$_ = $telnet->getline;
        $val .= $_ ? $_ : "" ; 
    }
    $telnet->close;

    return $val;
}

sub Load {
    my ($self) = @_;
    for ( split(/\n/, $self->{value}) ) {
        if ( m/^disk_io/gi ) {
          for (split) {
            next if m/^disk_io/gi;
            m/\(([0-9\,]+)\)\:\((\d+)\,(\d+)\,(\d+)\,(\d+)\,(\d+)\)/;
                                                                                                                           
            $self->{totio}{$1} = $2;
            $self->{rsect}{$1} = $3;
            $self->{rblk}{$1}  = $4;
            $self->{wsect}{$1} = $5;
            $self->{wblk}{$1}  = $6;
          }
        
	}elsif ( m/^ofiles (\d+)/ ) {
	    $self->{ofiles} = $1;

	}elsif ( m/^sockets: used (\d+)/ ) {
	    $self->{sockets} = $1;
	}

    }
}

sub uptime {
    my ($self) = @_;
    return defined $self->{uptime} ? $self->{uptime} : 0;
}

sub rsect {
    my ($self,$disk) = @_;
    return defined $self->{rsect}{$disk} ? $self->{rsect}{$disk} : "U";
}

sub wsect {
    my ($self,$disk) = @_;
    return defined $self->{wsect}{$disk} ? $self->{wsect}{$disk} : "U";
}

sub rblk {
    my ($self,$disk) = @_;
    return defined $self->{rblk}{$disk} ? $self->{rblk}{$disk} : "U";
}

sub wblk {
    my ($self,$disk) = @_;
    return defined $self->{wblk}{$disk} ? $self->{wblk}{$disk} : "U";
}

sub ofiles {
    my ($self) = @_;
    return defined $self->{ofiles} ? $self->{ofiles} : "U";
}

sub sockets {
    my ($self) = @_;
    return defined $self->{sockets} ? $self->{sockets} : "U";
}


1;
