package RRD::Cache::RT;

#
# Cache::RT cache progam
# Reads/Write RT statistics
# RT can be found on http://www.fsck.com/projects/rt/
#
# $Id: :
#

use strict;
use RRD::Cache;
use Net::Telnet;
use Data::Dumper;

use vars qw(@ISA $ifDescrOid $TIMEOUT);
@ISA = qw(RRD::Cache);

$TIMEOUT = 300;

sub GetContent {
    my ($self) = @_;

    my ($port,$ip) = split("@",$self->{Target});
    my $telnet = new Net::Telnet(Host => $ip, 
    				 Port => $port, 
				 Timeout => 30,
				 Errmode => 'return' 
				);
    if ( ! $telnet ) { return undef; }

    my $val = "";
    while(! $telnet->eof ) { 
	$_ = $telnet->getline;
        $val .= $_ ? $_ : "" ; 
    }
    $telnet->close;

    return $val;
}

sub Load {
    my ($self) = @_;
    for ( split(/\n/, $self->{value}) ) {
	chop;
	next if m/Created.*Updated/gi;
	next if m/^$/;
	if ( m/(\d+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+\s+\S+\s+\d+\s+[0-9\:]+\s+\d+)\s+(\S+\s+\S+\s+\d+\s+[0-9\:]+\s+\d+)/gi ) {

	    my $id   = $1;
	    my $stat = $2;
	    my $own  = $3;
	    my $que  = $4;
#   	    my $creat= parsedate($5);
# 	    my $upd  = parsedate($6);

	    $self->{new}{$own}{$que}++  if $stat =~ m/new/;
	    $self->{open}{$own}{$que}++ if $stat =~ m/open/;
	}
    }
}

sub get_new_own_q {
    my ($self,$own,$q) = @_;
    return defined $self->{new}{$own}{$q} ? $self->{new}{$own}{$q} : 0;
}

sub get_open_own_q {
    my ($self,$own,$q) = @_;
    return defined $self->{open}{$own}{$q} ? $self->{open}{$own}{$q} : 0;
}

1;
