package RRD::Cache::SNMP::ifIndex;

#
# Cache::SNMP cache progam
# Reads/Write ifindex info
#
# $Id: ifIndex.pm,v 1.5 2003/04/28 21:50:47 tommy Exp $
#

use strict;
use SNMP_util;
use RRD::Cache;
use RRD::Info qw(LogEntry);
use vars qw(@ISA $ifDescrOid $TIMEOUT);
@ISA = qw(RRD::Cache);

# This one can be used in most cases
$ifDescrOid  = "1.3.6.1.2.1.2.2.1.2";

# hardcoded default timeout 4 hrs
$TIMEOUT = 14400;

sub errmsg {
    my ($self) = @_;
    return $self->{errmsg};
}

sub GetContent {
    my ($self) = @_;

    my $oid = $self->{ifDescrOid} || $ifDescrOid;
    my @res = snmpwalk($self->{Target},$oid);
    return undef unless defined $res[0];

    if ( defined $res[0] ) {
        my $r = '';
        foreach (@res) { $r.=$_."\n"; }
        return $r;
    }else{
        return undef;
    }
}

sub Load {
}

sub ifIndex {
    my ($self,$iface) = @_;

    $self->{errmsg} = "";
    if ( ! $self->{value} ) {
	$self->{errmsg} = "ifIndex expired for $iface";
        return undef;
    }
 
    $self->{value} =~ m/([0-9.]+)\:$iface/i;
    $self->{errmsg} = "ifIndex not found for $iface" if ! $1;
    return $1;
}


1;
