package RRD::Config;

#
# RRDBrowse config file reader
#
# $Id: Config.pm,v 1.3 2002/10/06 12:36:33 tommy Exp $
#
#
use strict;
use Exporter;
use vars qw(@ISA @EXPORT %config);

@ISA = qw(Exporter);
@EXPORT = qw(%config);

my @REQUIRED = qw(basepath nfopath pngpath rrdpath pagepath cachepath showvars);
Getconfig();

sub Getconfig {
    if ( 
      ! open(F,"/usr/local/etc/rrdbrowse.conf")  &&
      ! open(F,"/etc/rrdbrowse.conf")  &&
      ! open(F,"~/.rrdbrowse.conf")  &&
      ! open(F,"./rrdbrowse.conf") 
    ) { die "no rrdbrowse.conf found!\n"; }



    while(<F>){
        chop;
	next if ( /^#/ || /^$/ );
        
	if ( /^(\w+)\s+=\s+(.*)$/ ) {
	    $config{$1} = $2;
	}
    }
    close F;
 
    while ($_=shift @REQUIRED){
        die "Missing $_ in config\n" unless defined $config{$_};
    }
}



1;

