package RRD::Function::apabpr;

#
# RRD/Function Apache Bytes per Request 
#
# $Id: apabpr.pm,v 1.2 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use RRD::Cache::Apache;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:load:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my $val = new RRD::Cache::Apache( Target => $self->{Target} );
    $val->Get;

    my $c = $val->bytes_per_req;

    $self->{LastRead} = "bytes_per_request: $c";
    RRDs::update($self->{RRD}, "N:$c" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Bytes per Request", 
	"-s ".$time,
	"DEF:cpu=".$self->{RRD}.":load:AVERAGE",
        "LINE2:cpu#00CC00:Bytes per Request ",
        "GPRINT:cpu:LAST:Current\\: %.0lf  ",
        "GPRINT:cpu:MAX:Max\\: %.0lf  ",
        "GPRINT:cpu:AVERAGE:Average\\: %.0lf \\l",
	$self->Defaults,
    );
}

1;
