package RRD::Function::apabw;

#
# RRD/Function Apache Total bandwidth 
#
# $Id: apabw.pm,v 1.6 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use RRD::Function::apaxs;
use RRD::Cache::Apache;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Function::apaxs);


sub Update {
    my ($self) = @_;

    my $val = new RRD::Cache::Apache( Target => $self->{Target} );
    $val->Get;

    if ( $val->uptime < 300 ) {
        $self->{LastRead} = "traffic: none";
        RRDs::update($self->{RRD}, "N:U");
    }else{
        my $tt = $val->total_bytes;
        $self->{LastRead} = "traffic: $tt";
        RRDs::update($self->{RRD}, "N:$tt");
    }
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Bandwidth", 
	"-s ".$time,
	"DEF:v1=".$self->{RRD}.":temp:AVERAGE",
	"CDEF:temp=v1,8,* ",

        "LINE2:temp#FF0000:Bandwidth ",
        "GPRINT:temp:LAST:Current\\: %.0lf bps  ",
        "GPRINT:temp:MAX:Max\\: %.0lf bps  ",
        "GPRINT:temp:AVERAGE:Average\\: %.0lf bps\\l",
	$self->Defaults,
    );
}
1;
