package RRD::Function::apacpu;

#
# RRD/Function Apache CPU Load
#
# $Id: apacpu.pm,v 1.4 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use RRD::Cache::Apache;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:load:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my $val = new RRD::Cache::Apache( Target => $self->{Target} );
    $val->Get;

    my $c = $val->cpu_load;

    $self->{LastRead} = "load: $c";
    RRDs::update($self->{RRD}, "N:$c" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v CPU Load", 
	"-s ".$time,
	"DEF:cpu=".$self->{RRD}.":load:AVERAGE",
        "LINE2:cpu#00CC00:CPU Load  ",
        "GPRINT:cpu:LAST:Current\\: %.0lf %% ",
        "GPRINT:cpu:MAX:Max\\: %.0lf %% ",
        "GPRINT:cpu:AVERAGE:Average\\: %.0lf %%\\l",
	$self->Defaults,
    );
}

1;
