package RRD::Function::apaproc;

#
# RRD/Function Apache Server States
#
# $Id: apaproc.pm,v 1.5 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use RRD::Cache::Apache;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:curr:GAUGE:600:U:U",
	"DS:idle:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my $val = new RRD::Cache::Apache( Target => $self->{Target} );
    $val->Get;

    my $u = $val->servers_busy;
    my $s = $val->servers_idle;

    $self->{LastRead} = "busy: $u idle: $s";
    RRDs::update($self->{RRD}, "N:$u:$s" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Processes", 
	"-s ".$time,
	"DEF:cur=".$self->{RRD}.":curr:AVERAGE",
	"DEF:idl=".$self->{RRD}.":idle:AVERAGE",
        "LINE2:cur#FF0000:Active ",
        "GPRINT:cur:LAST:Current\\: %.0lf active  ",
        "GPRINT:cur:MAX:Max\\: %.0lf active  ",
        "GPRINT:cur:AVERAGE:Average\\: %.0lf active\\l",
        "LINE2:idl#00CC00:Idle   ",
        "GPRINT:idl:LAST:Current\\: %.0lf idle    ",
        "GPRINT:idl:MAX:Max\\: %.0lf idle    ",
        "GPRINT:idl:AVERAGE:Average\\: %.0lf idle  \\l",
	$self->Defaults,
    );
}

1;
