package RRD::Function::apaxs;

#
# RRD/Function Apache Total Accesses 
#
# $Id: apaxs.pm,v 1.7 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use RRD::Cache::Apache;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);

my $MAX_ACCESSES = 4096;	# limit graph 

sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:temp:COUNTER:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my $val = new RRD::Cache::Apache( Target => $self->{Target} );
    $val->Get;

    if ( $val->uptime < 300 ) {
        $self->{LastRead} = "access: none";
        RRDs::update($self->{RRD}, "N:U");
    }else{
        $self->{LastRead} = "access: ".$val->total_accesses;
        RRDs::update($self->{RRD}, "N:".$val->total_accesses );
    }
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Accesses", 
	"-s ".$time,
	"DEF:v1=".$self->{RRD}.":temp:AVERAGE",
        "CDEF:temp=v1,0,$MAX_ACCESSES,LIMIT",
        "LINE2:temp#FF0000:Accesses ",
        "GPRINT:temp:LAST:Current\\: %.0lf axs/sec  ",
        "GPRINT:temp:MAX:Max\\: %.0lf axs/sec  ",
        "GPRINT:temp:AVERAGE:Average\\: %.0lf axs/sec\\l",
	$self->Defaults,
    );
}

1;
