package RRD::Function::apcload;

#
# RRD/Function APC UPS Output Load meter
#
# $Id: apcload.pm,v 1.2 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);

sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:temp:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;
 
    my ($res) = snmpget($self->{Target},"1.3.6.1.4.1.318.1.1.1.4.2.3.0");

    return unless defined $res;

    $self->{LastRead} = $res;
    RRDs::update($self->{RRD}, "N:$res" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Load", 
	"-s ".$time,
	"DEF:temp=".$self->{RRD}.":temp:AVERAGE",
        "LINE2:temp#FF0000:Output Load",
        "GPRINT:temp:LAST:Current\\: %.0lf %%  ",
        "GPRINT:temp:MAX:Max\\: %.0lf %%  ",
        "GPRINT:temp:AVERAGE:Average\\: %.0lf %%\\l",
	$self->Defaults,
    );
}

1;
