package RRD::Function::apctemp;

#
# RRD/Function APC UPS Temperature meter
#
# $Id: apctemp.pm,v 1.5 2002/09/26 17:11:48 tommy Exp $

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);

sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:temp:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;
 
    my ($res) = snmpget($self->{Target},"1.3.6.1.4.1.318.1.1.1.2.2.2.0");

    return unless defined $res;

    $self->{LastRead} = $res;
    RRDs::update($self->{RRD}, "N:$res" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Temperature", 
	"-s ".$time,
	"DEF:temp=".$self->{RRD}.":temp:AVERAGE",
        "LINE2:temp#FF0000:Battery Temperature",
        "GPRINT:temp:LAST:Current\\: %.0lf C  ",
        "GPRINT:temp:MAX:Max\\: %.0lf C  ",
        "GPRINT:temp:AVERAGE:Average\\: %.0lf C\\l",
	$self->Defaults,
    );
}

1;
