package RRD::Function::apctime;

#
# RRD/Function APC UPS Battery Time Left meter
#
# $Id: apctime.pm,v 1.5 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);

#$VERSION="$Revision: 1.5 $";


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:temp:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;
 
    my ($res) = snmpget($self->{Target},"1.3.6.1.4.1.318.1.1.1.2.2.3.0");
    return unless defined $res;

    my ($hr,$mn,$sc) = split(":",$res);
    my $min = (($hr * 3600) + ($mn * 60) + $sc)/60;

    $self->{LastRead} = $min;
    RRDs::update($self->{RRD}, "N:$min" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Time Left", 
	"-s ".$time,
	"DEF:temp=".$self->{RRD}.":temp:AVERAGE",
        "LINE2:temp#FF0000:Time on Battery",
        "GPRINT:temp:LAST:Current\\: %.0lf mins  ",
        "GPRINT:temp:MAX:Max\\: %.0lf mins  ",
        "GPRINT:temp:AVERAGE:Average\\: %.0lf mins\\l",
	$self->Defaults,
    );
}

1;
