package RRD::Function::ascinuse;

#
# RRD/Function Ascend Port Usage meter
#
# $Id: ascinuse.pm,v 1.4 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:temp:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;
 
    my ($res) = snmpget($self->{Target},"1.3.6.1.4.1.529.4.26.0");
    return unless defined $res;

    $self->{LastRead} = $res;
    RRDs::update($self->{RRD}, "N:$res" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Ports in Use", 
	"-s ".$time,
	"DEF:temp=".$self->{RRD}.":temp:AVERAGE",
        "LINE2:temp#FF0000:",
        "GPRINT:temp:LAST:Current\\: %.0lf users  ",
        "GPRINT:temp:MAX:Max\\: %.0lf users  ",
        "GPRINT:temp:AVERAGE:Average\\: %.0lf users\\l",
	$self->Defaults,
    );
}

1;
