package RRD::Function::bindqrs;

#
# RRD/Function Bind Nr of Queries Statistics generator
# Put the required stats collector script on
# the nameserver in snmpd.conf
#
# $Id: bindqrs.pm,v 1.3 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use RRD::Cache::Bind;

use Data::Dumper;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:a:COUNTER:600:U:U",
	"DS:ptr:COUNTER:600:U:U",
	"DS:mx:COUNTER:600:U:U",
	"DS:ns:COUNTER:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my $cache = new RRD::Cache::Bind( Target => $self->{Target} );
    $cache->Get;

    if ( $cache->uptime > 300 ) {
        my $a   = $cache->query_a;
        my $ptr = $cache->query_ptr;
        my $mx  = $cache->query_mx;
        my $ns  = $cache->query_ns;
        $self->{LastRead} = "a $a ptr $ptr mx $mx ns $ns";
        RRDs::update($self->{RRD}, "N:$a:$ptr:$mx:$ns" );
    }else{
        $self->{LastRead} = "a U ptr U mx U ns U";
        RRDs::update($self->{RRD}, "N:U:U:U:U" );
    }
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Queries per Second", 
	"-s ".$time,
	"DEF:val1=".$self->{RRD}.":a:AVERAGE",
	"DEF:val2=".$self->{RRD}.":ptr:AVERAGE",
	"DEF:val3=".$self->{RRD}.":mx:AVERAGE",
	"DEF:val4=".$self->{RRD}.":ns:AVERAGE",
        "LINE2:val1#00CC00:A Records  ",
        "GPRINT:val1:LAST:Current\\: %.0lf   ",
        "GPRINT:val1:MAX:Max\\: %.0lf   ",
        "GPRINT:val1:AVERAGE:Average\\: %.0lf \\l",
        "LINE2:val2#0000FF:PTR Records",
        "GPRINT:val2:LAST:Current\\: %.0lf   ",
        "GPRINT:val2:MAX:Max\\: %.0lf   ",
        "GPRINT:val2:AVERAGE:Average\\: %.0lf \\l",
        "LINE2:val3#AAAAAA:MX Records ",
        "GPRINT:val3:LAST:Current\\: %.0lf   ",
        "GPRINT:val3:MAX:Max\\: %.0lf   ",
        "GPRINT:val3:AVERAGE:Average\\: %.0lf \\l",
        "LINE2:val4#FF0000:NS Records ",
        "GPRINT:val4:LAST:Current\\: %.0lf   ",
        "GPRINT:val4:MAX:Max\\: %.0lf   ",
        "GPRINT:val4:AVERAGE:Average\\: %.0lf \\l",
	$self->Defaults,
    );
}

1;
