package RRD::Function::c72temp;

#
# RRD/Function Cisco C7200 Temperature meter
#
# $Id: c72temp.pm,v 1.5 2002/09/26 17:30:04 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);

#$VERSION="$Revision: 1.5 $";


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:cpu1:GAUGE:600:U:U",
	"DS:cpu2:GAUGE:600:U:U",
	"DS:cpu3:GAUGE:600:U:U",
	"DS:cpu4:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    # need to use walk coz we not no how many temp probes a device has 
    my @res = snmpwalk($self->{Target},"1.3.6.1.4.1.9.9.13.1.3.1.3");
    return unless defined $res[0];


    my @cpu = (0,0,0,0);
    my $i   = 0;
    foreach $l (@res) {
        my ($oid,$val) = split (":",$l,2);
        $cpu[$i++] = $val;
    }

    $self->{LastRead} = join(":",@cpu);
    RRDs::update($self->{RRD}, "N:".join(":",@cpu) );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Temperature", 
	"-s ".$time,
	"DEF:cpu1=".$self->{RRD}.":cpu1:AVERAGE",
	"DEF:cpu2=".$self->{RRD}.":cpu2:AVERAGE",
	"DEF:cpu3=".$self->{RRD}.":cpu3:AVERAGE",
	"DEF:cpu4=".$self->{RRD}.":cpu4:AVERAGE",
        "LINE2:cpu1#00CC00:Inlet   ",
        "GPRINT:cpu1:LAST:Current\\: %2.0lf C  ",
        "GPRINT:cpu1:MAX:Max\\: %.0lf C  ",
        "GPRINT:cpu1:AVERAGE:Average\\: %2.0lf C\\l",
        "LINE2:cpu2#0000FF:Outlet 1",
        "GPRINT:cpu2:LAST:Current\\: %2.0lf C  ",
        "GPRINT:cpu2:MAX:Max\\: %2.0lf C  ",
        "GPRINT:cpu2:AVERAGE:Average\\: %2.0lf C\\l",
        "LINE2:cpu3#EEEE00:Outlet 2",
        "GPRINT:cpu3:LAST:Current\\: %2.0lf C  ",
        "GPRINT:cpu3:MAX:Max\\: %2.0lf C  ",
        "GPRINT:cpu3:AVERAGE:Average\\: %2.0lf C\\l",
        "LINE2:cpu4#FF0000:Outlet 3",
        "GPRINT:cpu4:LAST:Current\\: %2.0lf C  ",
        "GPRINT:cpu4:MAX:Max\\: %2.0lf C  ",
        "GPRINT:cpu4:AVERAGE:Average\\: %2.0lf C\\l",
	$self->Defaults,
    );
}

1;
