package RRD::Function::fsstat;

#
# RRD/Function Linux Open Files Statistics generator
#
# $Id: fsstat.pm,v 1.5 2003/06/19 07:58:58 tommy Exp $
#

use RRDs;
use RRD::Template;
use Data::Dumper;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:ofiles:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my ($res) = snmpget($self->{Target},"1.3.6.1.4.1.2021.51.101.1");

    $self->{LastRead} = "fsstat $res";
    RRDs::update($self->{RRD}, "N:$res" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Open Files", 
	"-s ".$time,
	"DEF:val1=".$self->{RRD}.":ofiles:AVERAGE",
        "LINE2:val1#00CC00:Open Files  ",
        "GPRINT:val1:LAST:Current\\: %.0lf   ",
        "GPRINT:val1:MAX:Max\\: %.0lf   ",
        "GPRINT:val1:AVERAGE:Average\\: %.0lf \\l",
	$self->Defaults,
    );
}

1;
