package RRD::Function::linload;

#
# RRD/Function Linux Load 
#
# $Id: linload.pm,v 1.4 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:l1:GAUGE:600:U:U",
	"DS:l5:GAUGE:600:U:U",
	"DS:l15:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my ($user) = snmpget($self->{Target},".1.3.6.1.4.1.2021.10.1.3.1"); 
    return unless defined $user;
    my ($nice) = snmpget($self->{Target},".1.3.6.1.4.1.2021.10.1.3.2"); 
    return unless defined $nice;
    my ($system) = snmpget($self->{Target},".1.3.6.1.4.1.2021.10.1.3.3"); 
    return unless defined $system;

    $self->{LastRead} = "1min $user 5min $system 15min $nice";
    RRDs::update($self->{RRD}, "N:$user:$nice:$system" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Load Average", 
	"-s ".$time,
	"DEF:val1=".$self->{RRD}.":l1:AVERAGE",
	"DEF:val2=".$self->{RRD}.":l5:AVERAGE",
	"DEF:val3=".$self->{RRD}.":l15:AVERAGE",
        "LINE2:val1#00CC00:1 min ",
        "GPRINT:val1:LAST:Current\\: %.2lf  ",
        "GPRINT:val1:MAX:Max\\: %.2lf  ",
        "GPRINT:val1:AVERAGE:Average\\: %.2lf\\l",
        "LINE2:val2#0000FF:5 min ",
        "GPRINT:val2:LAST:Current\\: %.2lf  ",
        "GPRINT:val2:MAX:Max\\: %.2lf  ",
        "GPRINT:val2:AVERAGE:Average\\: %.2lf\\l",
        "LINE2:val3#FF0000:15 min",
        "GPRINT:val3:LAST:Current\\: %.2lf  ",
        "GPRINT:val3:MAX:Max\\: %.2lf  ",
        "GPRINT:val3:AVERAGE:Average\\: %.2lf\\l",
	$self->Defaults,
    );
}

1;
