package RRD::Function::linofiles;

#
# Linux Nr. of Open Files Statistics
# uses the ProcStat cache module
# put the procstat.sh binary on the remote server by telnet/inetd something like:
# procstat        stream  tcp     nowait  root    /usr/sbin/tcpd  /usr/sbin/procstat.sh
# procstat is portnumber xx used by "Target: xx@host" as specified in /etc/services
#
# $Id: linofiles.pm,v 1.1 2003/06/21 17:21:09 tommy Exp $
#

use RRDs;
use RRD::Template;
use RRD::Cache::ProcStat;

use Data::Dumper;

use vars qw(@ISA $VERSION @EXPORT @colors);
@EXPORT   = qw(@REQUIRED);
@ISA      = qw(RRD::Template);

sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:ofiles:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my $cache = new RRD::Cache::ProcStat( Target => $self->{Target} );
    $cache->Get;

    my $update = "N:". $cache->ofiles;
    $self->{LastRead} = $update;
    RRDs::update($self->{RRD}, $update);
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Open Files", 
	"-s ".$time,
	"DEF:of=".$self->{RRD}.":ofiles:AVERAGE",
        "LINE2:of#FF0000:Open Files ",
        "GPRINT:of:LAST:Current\\: %.0lf   ",
        "GPRINT:of:MAX:Max\\: %.0lf   ",
        "GPRINT:of:AVERAGE:Average\\: %.0lf \\l",
	$self->Defaults,
    );
}

1;
