package RRD::Function::linproc;

#
# RRD/Function Linux process counter
# host.hrSystem.hrSystemProcesses.0
#
# $Id: linproc.pm,v 1.4 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:memfree:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my ($res) = snmpget($self->{Target},"1.3.6.1.2.1.25.1.6.0"); 
    return unless defined $res;

    $self->{LastRead} = $res;
    RRDs::update($self->{RRD}, "N:$res" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Processes", 
	"-s ".$time,
	"DEF:memfree=".$self->{RRD}.":memfree:AVERAGE",
        "LINE2:memfree#FF0000:",
        "GPRINT:memfree:LAST:Current\\: %.0lf%s  ",
        "GPRINT:memfree:MAX:Max\\: %.0lf%s  ",
        "GPRINT:memfree:AVERAGE:Average\\: %.0lf%s\\l",
	$self->Defaults,
    );
}

1;
