package RRD::Function::oidderive;

#
# RRD/Function Generic OID Counter (uses the DERIVE datasource with min 0)
#
# Can be useful for counters that might reset on other points than the
# 32 or 64 bit mark.
#
# 2003/01/08 Ingimar Robertsson <iar@pjus.is>
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:g1:DERIVE:600:0:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;
 
    my ($res) = snmpget($self->{Target},$self->{OID});
    return unless defined $res;

    $self->{LastRead} = $res;
    RRDs::update($self->{RRD}, "N:$res" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v ".$self->{Title}, 
	"-s ".$time,
	"DEF:temp=".$self->{RRD}.":g1:AVERAGE",
        "LINE2:temp#FF0000:",
        "GPRINT:temp:LAST:Current\\: %.0lf ",
        "GPRINT:temp:MAX:Max\\: %.0lf ",
        "GPRINT:temp:AVERAGE:Average\\: %.0lf \\l",
	$self->Defaults,
    );
}

1;
