package RRD::Function::oidgauge;

#
# RRD/Function Generic OID Gauge
#
# $Id: oidgauge.pm,v 1.4 2002/09/26 17:11:48 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:g1:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;
 
    my ($res) = snmpget($self->{Target},$self->{OID});
    return unless defined $res;

    $self->{LastRead} = $res;
    RRDs::update($self->{RRD}, "N:$res" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v ".$self->{Title}, 
	"-s ".$time,
	"DEF:temp=".$self->{RRD}.":g1:AVERAGE",
        "LINE2:temp#FF0000:",
        "GPRINT:temp:LAST:Current\\: %.0lf ",
        "GPRINT:temp:MAX:Max\\: %.0lf ",
        "GPRINT:temp:AVERAGE:Average\\: %.0lf \\l",
	$self->Defaults,
    );
}

1;
