package RRD::Function::port64;

#
# RRD/Function Cisco 64 bit port meter
#
# $Id: port64.pm,v 1.8 2002/10/18 22:17:56 tommy Exp $
#

use RRDs;
use RRD::Function::port;
use SNMP_util;
use BER;
use RRD::Cache::SNMP::Uptime;

# we export @REQUIRED because this module is acting as a template
# @REQUIRED is again taken from function::port itself
use vars qw(@ISA @EXPORT);
@ISA    = qw(RRD::Function::port);
@EXPORT = qw(@REQUIRED);

sub _getv2 {
    my ($self,$val) = @_;

    my $if = $self->ifIndex || return undef;
    my ($comm,$ip) = split("@",$self->{Target});
    my $oid = encode_oid(1,3,6,1,2,1,31,1,1,1,$val,$if);
    my $session = SNMPv2c_Session->open($ip,$comm,161)
 	|| return undef;
    
    $session->get_request_response($oid) || return undef;
    my ($bs) = $session->decode_get_response($session->{pdu_buffer});
    my ($b,$x) = decode_sequence($bs);
    my ($id,$value) = decode_by_template($b,"%O%@");
   
    return pretty_print($value);
}

sub Update {
    my ($self) = @_;

    my $cache = new RRD::Cache::SNMP::Uptime( Target=>$self->{Target} );
    $cache->Get || return undef;

    if ( $cache->uptime < 300 ) {
        $self->{LastRead} = "in U out U";
        RRDs::update($self->{RRD},"N:U:U");
    }else{
        my $in  = $self->_getv2(6);
        return unless defined $in;
        my $out = $self->_getv2(10);
        return unless defined $out;

        $self->{LastRead} = "in $in out $out";
        RRDs::update($self->{RRD},"N:$in:$out");
    }
}

1;
