package RRD::Function::telnet;

#
# RRD/Function Generic Telnet value parser
# The first line returned from a telnet connection is used. 
# used for simple counter-returning servers
# could be used to plot sendmail status codes or such ;)
# Target: port@host
#
# $Id: telnet.pm,v 1.5 2002/09/27 14:01:27 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;
use Net::Telnet;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:cpu1:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my ($port,$ip) = split("@",$self->{Target});
    my $telnet = new Net::Telnet( Host => $ip, 
    				  Port => $port, 
				  Timeout => 30, 
				  Errmode => 'return' 
				);
    if ( ! $telnet ) { return; }
    my $val = $telnet->getline;
    chop $val;
    $telnet->close;

    $self->{LastRead} = $val;
    RRDs::update($self->{RRD}, "N:$val" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v ".$self->{Title},
	"-s ".$time,
	"DEF:cpu1=".$self->{RRD}.":cpu1:AVERAGE",
        "LINE2:cpu1#FF0000",
        "GPRINT:cpu1:LAST:Current\\: %.0lf  ",
        "GPRINT:cpu1:MAX:Max\\: %.0lf  ",
        "GPRINT:cpu1:AVERAGE:Average\\: %.0lf\\l",
	$self->Defaults,
    );
}

1;
