package RRD::Function::w2kcpu;

#
# RRD/Function Windows2000
# http://www.wtcs.org/snmp4tpc/
#
# old changelog:
# 0.02 initial
# 0.03 limit 200, dual cpu
#
# $Id: w2kcpu.pm,v 1.1 2003/02/05 20:48:29 tommy Exp $
#

use RRDs;
use RRD::Template;
use RRD::Cache::SNMP::Uptime;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:user:COUNTER:600:U:U",
	"DS:system:COUNTER:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my $cache = new RRD::Cache::SNMP::Uptime( Target=>$self->{Target} );
    $cache->Get;
    if ( $cache->uptime < 300 ) {
        $self->{LastRead} = "user U system U";
        RRDs::update($self->{RRD},"N:U:U");
    }else{
        my ($user) = snmpget($self->{Target},".1.3.6.1.4.1.311.1.1.3.1.1.2.1.4.1.48"); 
        return unless defined $user;
        my ($system) = snmpget($self->{Target},".1.3.6.1.4.1.311.1.1.3.1.1.2.1.5.1.48"); 
        return unless defined $system;

        $self->{LastRead} = "user $user system $system";
        RRDs::update($self->{RRD}, "N:$user:$system" );
    }
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
        $self->DefaultOpts,
	"-v CPU Load", 
	"-s ".$time,
	"DEF:v1=".$self->{RRD}.":user:AVERAGE",
	"DEF:v2=".$self->{RRD}.":system:AVERAGE",
        "CDEF:val1=v1,0,100,LIMIT,100,*",
        "CDEF:val2=v2,0,100,LIMIT,100,*",
        "LINE2:val1#00CC00:User Time  ",
        "GPRINT:val1:LAST:Current\\: %.0lf %%  ",
        "GPRINT:val1:MAX:Max\\: %.0lf %%  ",
        "GPRINT:val1:AVERAGE:Average\\: %.0lf %%\\l",
        "LINE2:val2#0000FF:Privileged Time  ",
        "GPRINT:val2:LAST:Current\\: %.0lf %%  ",
        "GPRINT:val2:MAX:Max\\: %.0lf %%  ",
        "GPRINT:val2:AVERAGE:Average\\: %.0lf %%\\l",
	$self->Defaults,
    );
}

1;
