package RRD::Function::w2kmem;

#
# RRD/Function Windows2000 memory counter
#
# $Id: w2kmem.pm,v 1.1 2003/02/05 20:48:29 tommy Exp $
#

use RRDs;
use RRD::Template;
use SNMP_util;

use vars qw(@ISA $VERSION);
@ISA   = qw(RRD::Template);


sub CreateDB {
    my ($self) = @_;

    RRDs::create($self->{RRD},
	"DS:available:GAUGE:600:U:U",
	"DS:committed:GAUGE:600:U:U",
	"DS:cache:GAUGE:600:U:U",
	@stdrra,
    );
}

sub Update {
    my ($self) = @_;

    my ($avail)  = snmpget($self->{Target},".1.3.6.1.4.1.311.1.1.3.1.1.1.2.0");
    return unless defined $avail;
    my ($commit)   = snmpget($self->{Target},".1.3.6.1.4.1.311.1.1.3.1.1.1.3.0");
    return unless defined $commit;
    my ($cache)  = snmpget($self->{Target},".1.3.6.1.4.1.311.1.1.3.1.1.1.19.0");
    return unless defined $cache;

    $self->{LastRead} = "available $avail committed $commit cache $cache";
    RRDs::update($self->{RRD}, "N:$avail:$commit:$cache" );
}

sub Graph {
    my ($self,$file,$time) = @_;

    RRDs::graph($self->{OutDir}."/$file.png",
    	$self->DefaultOpts,
	"-v Memory Usage", 
	"-s ".$time,
	"DEF:val1=".$self->{RRD}.":available:AVERAGE",
	"DEF:val2=".$self->{RRD}.":committed:AVERAGE",
	"DEF:val3=".$self->{RRD}.":cache:AVERAGE",
        "LINE2:val1#00CC00:Available ",
        "GPRINT:val1:LAST:Current\\:%6.1lf %sb  ",
        "GPRINT:val1:MAX:Max\\:%6.1lf %sb  ",
        "GPRINT:val1:AVERAGE:Average\\:%6.1lf %sb\\l",
        "LINE2:val2#0000FF:Committed ",
        "GPRINT:val2:LAST:Current\\:%6.1lf %sb  ",
        "GPRINT:val2:MAX:Max\\:%6.1lf %sb  ",
        "GPRINT:val2:AVERAGE:Average\\:%6.1lf %sb\\l",
        "LINE2:val3#FF0000:Cache ",
        "GPRINT:val3:LAST:Current\\:%6.1lf %sb  ",
        "GPRINT:val3:MAX:Max\\:%6.1lf %sb  ",
        "GPRINT:val3:AVERAGE:Average\\:%6.1lf %sb\\l",
	$self->Defaults,
    );
}

1;
