#!/usr/bin/perl -w

#
# rrdbrowse cgi browser 
#
# $Id: rb.cgi,v 1.6 2003/04/28 07:39:25 tommy Exp $
#

use strict;

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DirHandle;

use RRD::Info;
use RRD::Config;
use RRD::Web qw(GetDirHash);

my $cgi = new CGI;
my $mode = $cgi->param('mode') || "browse";
my $file = $cgi->param('file');
my $dir  = $cgi->param('dir');
my $time = $cgi->param('time');

my $ME  = $ENV{SCRIPT_NAME};

sub htmlHeader {
    my $i = "SRC=http://www.chiparus.org/c/h/i/p/a/r/u/s/logo2.gif WIDTH=275 HEIGHT=58";
    $i = $config{image} if $config{image};
    my $t = "RRD Statistics";
    $t = $config{title} if $config{title};

    my $s = $config{stylesheet};
    print <<HTMLHEADER;
<HTML>
<HEAD>
<TITLE>$t - RRDBrowse</TITLE>
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="Refresh" CONTENT="300">
<STYLE TYPE="text/css">
  th    { font-size: 10px; 
	  font-family: Verdana, Arial, Times; 
	  color: #000060; 
	  background: #a0a0c0; }
  td	{ font-size: 9px; 
	  font-family: Verdana, Arial, Times; 
	  color: #000000; 
	  background: #e0e0f0; }
  td.dirlist { font-size: 10px; 
	  font-family: Verdana, Arial, Times; 
	  color: #000000; 
	  background: #ffffff; }
  h1	{ font-size: 18px;
	  font-family: Helvetica, Verdana, Arial, Times;
	  color: #000000; }
  h3	{ font-size: 12px;
	  font-family: Helvetica, Verdana, Arial, Times;
	  color: #000000; }
  body	{ color: #000066;
          font-size: 9px; 
	  font-family: Verdana, Arial, Times; 
	  background: #ffffff; }
</STYLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="$s">
</HEAD>

<BODY BGCOLOR="#F0F0F0">
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=4 WIDTH=100%>
<TR VALIGN=TOP>
<TD VALIGN=CENTER ALIGN=LEFT>
<h1>$t</H1>
[ <A HREF="$ME">Home</A> ] -
[ <A HREF="javascript:history.go(-1);">Back</A> ] -
[ <A HREF="$ME?mode=browse">Browse</A> ] -
[ <A HREF="$ME?mode=browsepage">Pages</A> ]
</TD>
<TD ALIGN=RIGHT>
<IMG $i>
</TD>
</TR></TABLE>
<BR>
HTMLHEADER
}

sub htmlFooter {
    print <<HTMLFOOTER;
<HR>
<ADDRESS>
<A HREF="http://www.rrdbrowse.org/">RRDBrowse 1.6</a> Copyright 2002 Tommy van Leeuwen<BR>
</ADDRESS>
</BODY>
</HTML>
HTMLFOOTER
}

#
# handle images first
#

if ( $mode eq 'thumb' ) {
    print $cgi->header(-type => "image/png");
    $time = "1day" unless $time;
    RRD::Web::ShowThumb($file,$time);
    undef $cgi;
    exit;
}elsif ( $mode eq 'image' ) {
    print $cgi->header(-type => "image/png");
    RRD::Web::ShowImage($file,$time);
    undef $cgi;
    exit;
}

#
# main web interface program
#

print $cgi->header;
htmlHeader();

if ( $mode eq "browse" || $mode eq "browsepage" ) {

    my $basepath = $config{nfopath};
    $basepath = $config{pagepath} if $mode eq "browsepage";

    my $hash = GetDirHash($dir,$basepath);
    my %files = %{$hash->{files}};
    my %dirs = %{$hash->{dirs}};

    my @fkeys = sort { $files{$a} cmp $files{$b} } keys %files;
    my @dkeys = sort { $dirs{$a} cmp $dirs{$b} } keys %dirs;

    print "<TABLE>";
    foreach (@dkeys) {
        print "<TR><TD CLASS=dirlist>";
	print "<A HREF=$ME?mode=$mode&dir=$_>";
	print "<IMG SRC=/icons/small/dir.gif BORDER=0> " if $config{icons};
	print "$dirs{$_}</A>";
	print "</TD><TD CLASS=dirlist>&nbsp;";
	print "</TD></TR>";
    }
    foreach (@fkeys) {
        my $m = "file"; my $i = "image2.gif";
	if ( m/\.pag$/ ) { $m = "page"; $i = "index.gif" }
        print "<TR><TD CLASS=dirlist>";
        print "<A HREF=$ME?mode=$m&file=$_>";
	print "<IMG SRC=/icons/small/$i BORDER=0> " if $config{icons};
	print "$_</A>";
	print "</TD><TD CLASS=dirlist>$files{$_}";
	print "</TD></TR>";
    }
    print "</TABLE>";


}elsif ( $mode eq "file" ) {
    my $info = new RRD::Info("$config{nfopath}/$file");
    $info->CheckPaths;
    $info->Graph;

    print "<H3>";
    for ( split(/\s+/, $config{showvars}) ) {
        print "$_: ".$info->{$_}."<BR>\n" if $info->{$_};
    }
    print "</H3>";
    print "<IMG SRC=$ME?mode=image&file=$file&time=1day   BORDER=0><P>\n";
    print "<IMG SRC=$ME?mode=image&file=$file&time=1week  BORDER=0><P>\n";
    print "<IMG SRC=$ME?mode=image&file=$file&time=8weeks BORDER=0><P>\n";
    print "<IMG SRC=$ME?mode=image&file=$file&time=2years BORDER=0><P>\n";
    undef $info;

}elsif ( $mode eq "page" ) {
    if ( ! open(F,"$config{pagepath}/$file") && ! open(F,"$config{nfopath}/$file") ) {
        croak("Can't open page $!");
    }
    <F>;
    while(<F>) {
        chop;
        my $nfo = $_;
	if ( ! -f "$config{nfopath}$nfo" ) {
	    print "<H4>$nfo is gone</H4><P>";
	    next;
	}
        my $info = new RRD::Info("$config{nfopath}$nfo");
        $info->GraphThumb;
        print "<H4>$info->{Description}</H4>\n";
        print "<A HREF=$ME?mode=file&file=$nfo><IMG SRC=$ME?mode=thumb&file=$nfo&time=1day BORDER=0></A><P>\n";
        undef $info;
    }
    close F;

}else{
    print <<MESSAGE;
I really don't know what to put here. Choose browse or page from the menu.
MESSAGE
}

htmlFooter();
undef $cgi;
1;
